Imports Infragistics.Win
Imports Infragistics.Win.UltraWinTree

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents label2 As System.Windows.Forms.Label
    Friend WithEvents label1 As System.Windows.Forms.Label
    Friend WithEvents destinationTree As Infragistics.Win.UltraWinTree.UltraTree
    Friend WithEvents sourceTree As Infragistics.Win.UltraWinTree.UltraTree
    Private lastMouseDownPoint As Point = Point.Empty

    ' The KeyState property of the DragEventArgs is annoying to deal
    ' with since its type is not a .NET enumeration, so define the
    ' constant that we are interested in here.
    Private Const KEYSTATE_CONTROL As Integer = 8

    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.label2 = New System.Windows.Forms.Label()
        Me.label1 = New System.Windows.Forms.Label()
        Me.destinationTree = New Infragistics.Win.UltraWinTree.UltraTree()
        Me.sourceTree = New Infragistics.Win.UltraWinTree.UltraTree()
        CType(Me.destinationTree, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.sourceTree, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'label2
        '
        Me.label2.AutoSize = True
        Me.label2.Location = New System.Drawing.Point(228, 9)
        Me.label2.Name = "label2"
        Me.label2.Size = New System.Drawing.Size(60, 13)
        Me.label2.TabIndex = 7
        Me.label2.Text = "Destination"
        '
        'label1
        '
        Me.label1.AutoSize = True
        Me.label1.Location = New System.Drawing.Point(12, 9)
        Me.label1.Name = "label1"
        Me.label1.Size = New System.Drawing.Size(41, 13)
        Me.label1.TabIndex = 6
        Me.label1.Text = "Source"
        '
        'destinationTree
        '
        Me.destinationTree.Location = New System.Drawing.Point(224, 25)
        Me.destinationTree.Name = "destinationTree"
        Me.destinationTree.Size = New System.Drawing.Size(200, 232)
        Me.destinationTree.TabIndex = 5
        '
        'sourceTree
        '
        Me.sourceTree.Location = New System.Drawing.Point(8, 25)
        Me.sourceTree.Name = "sourceTree"
        Me.sourceTree.Size = New System.Drawing.Size(192, 232)
        Me.sourceTree.TabIndex = 4
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(432, 266)
        Me.Controls.Add(Me.label2)
        Me.Controls.Add(Me.label1)
        Me.Controls.Add(Me.destinationTree)
        Me.Controls.Add(Me.sourceTree)
        Me.Name = "Form1"
        Me.Text = "UltraTree_DragDrop"
        CType(Me.destinationTree, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.sourceTree, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        '	Populate the UltraTree controls
        Dim i As Integer
        Dim j As Integer

        For i = 1 To 10

            Dim node1 As UltraTreeNode = Me.sourceTree.Nodes.Add(Nothing, "Node " + i.ToString())
            Dim node2 As UltraTreeNode = Me.destinationTree.Nodes.Add(Nothing, "Node " + i.ToString())

            For j = 1 To 10

                node1.Nodes.Add(Nothing, node1.Key + "Child " + j.ToString())
                node2.Nodes.Add(Nothing, node2.Key + "Child " + j.ToString())
            Next j

        Next i

        '	Set the AllowDrop property of the destination tree
        '	to true so it accepts drops.
        Me.destinationTree.AllowDrop = True

        '	Set the HideSelection property of the destination tree
        '	to false so that its nodes' selected state is depicted
        '	even when the control does not have focus.
        Me.destinationTree.HideSelection = False

    End Sub


    Private Sub sourceTree_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles sourceTree.MouseDown

        '	Cache the point at which the mouse was pressed, so we can
        '	compare it to the drag threshold in MouseMove
        Me.lastMouseDownPoint = New Point(e.X, e.Y)

    End Sub

    Private Sub sourceTree_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles sourceTree.MouseMove
        Dim sourceTree As UltraTree = DirectCast(sender, UltraTree)

        '	We are only interested in this event when the left
        '	mouse button is pressed
        If e.Button = MouseButtons.Left Then

            '	Get the cursor position (as relative to the control's coordinate
            '	system) and determine whether it is within the drag threshold
            Dim cursorPos As Point = New Point(e.X, e.Y)

            Dim dragRect As Rectangle = New Rectangle(Me.lastMouseDownPoint, SystemInformation.DragSize)
            dragRect.X -= SystemInformation.DragSize.Width / 2
            dragRect.Y -= SystemInformation.DragSize.Height / 2

            '	If it is within the drag threshold, initiate the drag/drop operation,
            '	specifying the ActiveNode as the "drag node"
            If dragRect.Contains(cursorPos) Then
                sourceTree.DoDragDrop(sourceTree.ActiveNode, DragDropEffects.All)
            End If
        End If

    End Sub

    Private Sub destinationTree_DragOver(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles destinationTree.DragOver

        Dim destinationTree As UltraTree = DirectCast(sender, UltraTree)

        '	Get the cursor position (as relative to the control's coordinate
        '	system) and determine whether there is a node under it.
        Dim cursorPos As Point = destinationTree.PointToClient(New Point(e.X, e.Y))
        Dim nodeAtPoint As UltraTreeNode = destinationTree.GetNodeFromPoint(cursorPos)

        '	If there is no node under the cursor, show the "no drop" cursor
        If nodeAtPoint Is Nothing Then
            e.Effect = DragDropEffects.None
        Else
            '	If there is a node under the cursor, show either the 'Move'
            '	or 'Copy' cursor, based on whether the Control key is pressed
            If (e.KeyState And KEYSTATE_CONTROL) = KEYSTATE_CONTROL Then
                e.Effect = DragDropEffects.Copy
            Else
                e.Effect = DragDropEffects.Move
            End If


            '	Select the node under the cursor, to provide a visual
            '	cue as to what node will receive the drop operation,
            '	and refresh the display so the selection is shown immediately.
            nodeAtPoint.Selected = True
            destinationTree.Refresh()

        End If

    End Sub

    Private Sub destinationTree_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles destinationTree.DragDrop

        Dim destinationTree As UltraTree = DirectCast(sender, UltraTree)

        '	Get the cursor position (as relative to the control's coordinate
        '	system) and determine whether there is a node under it.
        Dim cursorPos As Point = destinationTree.PointToClient(New Point(e.X, e.Y))
        Dim destinationNode As UltraTreeNode = destinationTree.GetNodeFromPoint(cursorPos)

        If Not destinationNode Is Nothing Then

            '	Retrieve the drag data from the IDataObject and cast it to an UltraTreeNode
            Dim dragNode As UltraTreeNode = e.Data.GetData(GetType(UltraTreeNode))
            If Not dragNode Is Nothing Then

                '	This is not necessary to complete the drag, but most of
                '	the time the end user will want to begin working with
                '	the tree that received the drop.
                destinationTree.Select()
                destinationTree.ActiveNode = destinationNode

                '	If the Control key is pressed, clone the drag node (and any
                '	descendant nodes) and add them to the destination node's
                '	Nodes collection. If the Control key is not pressed, use
                '	the Reposition method, which removes the nodes from the source
                '	collection and adds them to the destination Nodes collection.
                If ((e.KeyState And KEYSTATE_CONTROL) = KEYSTATE_CONTROL) Then

                    Dim dragNodeClone As UltraTreeNode = dragNode.Clone()
                    destinationNode.Nodes.Add(dragNodeClone)
                Else
                    dragNode.Reposition(destinationNode.Nodes)
                End If
            End If
        End If

    End Sub
End Class
